#ifndef SETUP_H_
#define SETUP_H_

#include "structs.h"

PetscErrorCode GridInputSetup(const char filename[], St_Grid *ret,
    St_InputBcond **firstBcond, St_InputBcond **lastBcond);
PetscErrorCode BcondSetup();
PetscErrorCode GeomSetup(MeshRegion region, St_Grid Grid, St_Geom *ret);
PetscErrorCode WallDistanceSetup();
PetscErrorCode GlobalSetup();
PetscErrorCode Init();
PetscErrorCode InputSetup();
PetscErrorCode InterpSetup();
PetscErrorCode LocalSetup();
PetscErrorCode PropSetup();
PetscErrorCode Setup();
PetscErrorCode SysSetup();
PetscErrorCode TransSetup();
PetscErrorCode VarSetup();

PetscErrorCode DestroyBConds();
PetscErrorCode DestroyGeom();
PetscErrorCode DestroyInterp();
PetscErrorCode DestroyLocal();
PetscErrorCode DestroyPatches();
PetscErrorCode DestroyProps();
PetscErrorCode DestroyVariables();

#endif /* SETUP_H_ */
