#ifndef INTERP_H_
#define INTERP_H_

#include "structs.h"

PetscErrorCode EvaluateLinearInterp();
PetscErrorCode EvaluateVariInterp();

/* Functions defined in the file "convsch.c": */
PetscErrorCode FluxLimiterUNIFORM(PetscInt ivar, PetscInt icell,
		PetscInt ineighb, PetscReal upwdelta, PetscReal dowdelta,
		PetscReal *value);
PetscErrorCode FluxLimiterUPWIND(PetscInt icell, PetscInt ineighb,
		PetscReal upwdelta, PetscReal dowdelta, PetscReal *value);
PetscErrorCode FluxLimiterCDS(PetscInt icell, PetscInt ineighb,
		PetscReal upwdelta, PetscReal dowdelta, PetscReal *value);
PetscErrorCode FluxLimiterSMART(PetscInt icell, PetscInt ineighb,
		PetscReal upwdelta, PetscReal dowdelta, PetscReal *value);

/* Functions defined in the file "mominterp.c" */
PetscErrorCode OmicaFunct(Ptr_Prop);
PetscErrorCode OmicpFunct(Ptr_Prop);
PetscErrorCode Tmic1Funct(Ptr_Prop);
PetscErrorCode Tmic2Funct(Ptr_Prop);
PetscErrorCode MICorrFunct(Ptr_Prop);
PetscErrorCode alphaRlxMI(PetscInt idir, PetscInt icell, PetscReal *ret);

/* Functions defined in the file "termA.c": */
PetscErrorCode ConvFunct(Ptr_Prop Prop);
PetscErrorCode DiffFunct(Ptr_Prop Prop);
PetscErrorCode MIPresContFunct(Ptr_Prop Prop);
PetscErrorCode DPDXFunct(Ptr_Prop Prop);
PetscErrorCode Utau2Funct(Ptr_Prop Prop);
PetscErrorCode Utau2PrevFunct(Ptr_Prop Prop);

/* Functions defined in the file "trans.c" */
PetscErrorCode TransExp1Funct(Ptr_Prop);
PetscErrorCode TransExpEUL2Funct(Ptr_Prop);
PetscErrorCode TransExpADM2Funct(Ptr_Prop);
PetscErrorCode TransExpADM3Funct(Ptr_Prop);
PetscErrorCode TransExpADMauxFunct(Ptr_Prop);

/* Functions defined in the "turbulence.c" file: */
PetscErrorCode ViscTLESFunct(Ptr_Prop);
PetscErrorCode ViscTKEFunct(Ptr_Prop);
PetscErrorCode ViscTotal(Ptr_Prop);
PetscErrorCode TurmodPkFunct(Ptr_Prop);
PetscErrorCode TurmodGbFunct(Ptr_Prop);
PetscErrorCode KEsourceBcondBFunct(Ptr_Prop);
PetscErrorCode EPsourceBcondBFunct(Ptr_Prop);

#endif /* INTERP_H_ */
